package com.qhtx.eta.common.eunms;

import lombok.Getter;

@Getter
public enum ErrorEnum {

    /**
     * SYSTEM INNER ERROR CODE
     */
    BEAN_COVERT_TO_MAP_ERROR("00001", "bean转换成map失败"),
    PARSE_TIME_ERROR("00002", "解析时间错误"),
    DB_ERROR("00003", "数据库执行异常"),
    /**
     * SYSTEM ERROR CODE
     */
    SYSTEM_ERROR("10001", "系统错误:[%s]"),
    API_NOT_FOUND("10002", "API接口不存在"),
    PROXY_REGISTER_ERROR("10003", "注册接口代理失败"),
    API_RESPONSE_CONFIG_ERROR("10004", "API接口应答配置错误,应答类不能为NULL"),
    DATASOURCE_EXECUTE_ERROR("10005", "数据库执行异常[%s]"),
    INTERNAL_SERVER_ERROR("10006", "系统异常中断"),
    UNKNOWN_DATASOURCE_ERROR("10007", "未知数据源"),
    /*HTTP ERROR CODE*/
    HTTP_METHOD_NOT_ALLOWED("20001", "http请求方法不允许"), /*INTERNAL ERROR CODE*/ //HTTP ERROR CODE
    ILLEGAL_HEAD_PARAM("20002", "非法的head参数类型{%s}:${%s}"), /*INTERNAL ERROR CODE*/
    ILLEGAL_IPV4_ADDRESS("20003", "非法的ipv4地址"),
    ILLEGAL_IPV6_ADDRESS("20004", "非法的ipv6地址"),
    ILLEGAL_URL_ADDRESS("20005", "非法的URL地址"),

    URL_NOT_NULL("20005", "url不能为空"),

    API_CALL_ERROR("20006", "调用api失败:[%d:%s]"),

    PARSE_RESPONSE_ERROR("20007", "解析返回结果失败%s"),
    RESPONSE_EMPTY_ERROR("20008", "接口请求应答为空"),
    PARAM_TYPE_ERROR("20009", "参数类型错误"),


    DW_INDEX_TABLE_CODE_GET_ERROR("20010", "获取指标框架[table_code]失败"),
    DW_HZ_ROOT_PATH_NOT_EXIST("20011", "ETA投研平台指标根目录不存在"),
    DW_INDEX_NOT_FOUND("20012", "DW指标信息不存在"),
    INDEX_AllREADY_ADD("20013", "指标已添加，请勿重复添加"),
    INDEX_UPDATE_ERROR("20013", "更新指标出错,指标异常"),
    PUSH_TO_ETA_ERROR("20014", "ETA数据推送失败"),
    INDEX_DEAL_LOCK_FAIL("20015", "指标更新锁获取失败"),
    ;
    private String code;
    private String msg;

    ErrorEnum(String code, String msg) {
        this.code = code;
        this.msg = msg;
    }

}
