package com.qhtx.eta.common.limiter;

import com.qhtx.eta.common.eunms.LimiterType;

import java.util.Map;
import java.util.ServiceLoader;
import java.util.concurrent.ConcurrentHashMap;

public enum LimiterProvider {
    INSTANCE;
    private final Map<LimiterType, Limiter<?>> cache = new ConcurrentHashMap<>();

    LimiterProvider() {
        ServiceLoader<Limiter> loader = ServiceLoader.load(Limiter.class);
        loader.forEach(provider -> {
            String limiterName = provider.getClass().getSimpleName();
            LimiterType type = LimiterType.getByName(limiterName);
            if (type != null) {
                cache.putIfAbsent(type, provider);
            }
        });
    }

    public Limiter<?> getLimiter(LimiterType type) {
        return cache.get(type);
    }
}
