package com.qhtx.eta.domain.api.http.response.eta;

import com.qhtx.eta.domain.entity.QuotaInfoDTO;
import com.qhtx.eta.common.constant.ETAConstants;
import lombok.Data;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.lang3.StringUtils;

import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.time.LocalDate;
import java.time.ZoneId;
import java.time.format.DateTimeFormatter;
import java.util.Date;
import java.util.List;
import java.util.stream.Collectors;

@Data
@Slf4j
public class QuotaInfoResponse extends ETAHttpResponse<ETAQuota, QuotaInfoDTO> {
    private static final long serialVersionUID = -5485763626281589776L;

    public List<QuotaInfoDTO> convertDataToDTO() {

        return this.getData().stream().map(item -> {
            QuotaInfoDTO result = new QuotaInfoDTO();
            result.setEdbName(item.getEdbName());
            result.setUniqueCode(item.getUniqueCode());
            result.setFrequency(item.getFrequency());
            result.setClassifyId(item.getClassifyId());
            result.setEdbCode(item.getEdbCode());
            result.setEdbSource(item.getSource());
            result.setEdbInfoId(item.getEdbInfoId());
            result.setEndDate(StrToDate(item.getEndDate()));
            result.setUnit(item.getUnit());
            result.setStartDate(StrToDate(item.getStartDate()));
            result.setLatestDate(StrToDate(item.getLatestDate()));
            result.setNoUpdate(item.getNoUpdate());
            result.setEdbSourceName(item.getSourceName());
            return result;
        }).filter(item -> item.getLatestDate() != null && item.getEndDate() != null && item.getStartDate() != null).collect(Collectors.toList());
    }

    private void printf(String str) {
        try {
            // 指定日志文件路径
            String logFilePath = "../log/output.json.log";

            // 创建一个PrintStream实例，指向日志文件
            PrintStream printStream = new PrintStream(logFilePath);

            // 将System.out替换为新创建的PrintStream实例
            System.setOut(printStream);
            // 你的对象
            // 打印JSON格式的对象到日志文件
            // 关闭资源是个好习惯，但在这个场景下可能不是必须的，因为程序结束时JVM会自动关闭
            printStream.close();
        } catch (FileNotFoundException e) {
            // 处理文件未找到异常
            e.printStackTrace();
        }
    }

    private Date StrToDate(String dateTime) {
        try {
            if (StringUtils.isEmpty(dateTime)) {
                return null;
            }
            DateTimeFormatter formatter = DateTimeFormatter.ofPattern(ETAConstants.DATE_PATTERN);
            return Date.from(LocalDate.parse(dateTime, formatter).atStartOfDay(ZoneId.of(ETAConstants.TIME_ZONE)).toInstant());
        } catch (Exception e) {
            return null;
        }
    }
}
