package com.qhtx.eta.domain.api.http.response.inner;

import com.qhtx.eta.common.constant.ETAConstants;
import lombok.Data;
import okhttp3.Response;

import java.io.Serializable;
import java.util.List;

@Data
public class InnerResponse implements Serializable {
    private static final long serialVersionUID = -5959366645709223497L;
    private Boolean success;
    private Boolean needRetry;
    private String errorMsg;
    private List<?> data;

    public static InnerResponse emptyResponse() {
        InnerResponse innerResponse = new InnerResponse();
        innerResponse.setSuccess(false);
        innerResponse.setNeedRetry(false);
        innerResponse.setErrorMsg(ETAConstants.ETA_EMPTY_RESPONSE_COMMENT);
        return innerResponse;
    }

    public static InnerResponse errorResponse(Response response) {
        InnerResponse innerResponse = new InnerResponse();
        innerResponse.setSuccess(false);
        innerResponse.setNeedRetry(false);
        innerResponse.setErrorMsg(response == null ? ETAConstants.UNKNOWN_ERROR : response.message());
        return innerResponse;
    }

    public static InnerResponse errorResponse(String errorMsg) {
        InnerResponse innerResponse = new InnerResponse();
        innerResponse.setSuccess(false);
        innerResponse.setNeedRetry(false);
        innerResponse.setErrorMsg(errorMsg);
        return innerResponse;
    }
}
