package com.qhtx.eta.domain.api.proxy.impl;

import com.qhtx.eta.common.eunms.ErrorEnum;
import com.qhtx.eta.common.exception.ETAException;
import com.qhtx.eta.domain.api.http.request.ETADataHttpRequest;
import com.qhtx.eta.domain.api.http.request.ETAPushIndexRequest;
import com.qhtx.eta.domain.api.proxy.ApiParameterProxy;
import com.qhtx.eta.domain.convert.DWIndexDataDTOConverter;
import com.qhtx.eta.domain.entity.DWIndexDTO;
import com.qhtx.eta.domain.entity.DWIndexDataDTO;

/**
 * @author mac
 */
public class ETAPushParameterProxy extends ApiParameterProxy<ETAPushIndexRequest> {
    @Override
    protected ETAPushIndexRequest acceptParam(Object data) {
        if (data instanceof DWIndexDTO) {
            ETAPushIndexRequest etaDataHttpRequest = new ETAPushIndexRequest();
            etaDataHttpRequest.setDataList(DWIndexDataDTOConverter.INSTANCE.convertToETAPushDataList(((DWIndexDTO) data).getDataList()));
            etaDataHttpRequest.setFrequency(((DWIndexDTO) data).getFrequency());
            etaDataHttpRequest.setSourceName(((DWIndexDTO) data).getSourceName());
            etaDataHttpRequest.setRemark(((DWIndexDTO) data).getRemark());
            etaDataHttpRequest.setIndexCode(((DWIndexDTO) data).getIndexCode());
            etaDataHttpRequest.setIndexName(((DWIndexDTO) data).getIndexName());
            etaDataHttpRequest.setUnit(((DWIndexDTO) data).getUnit());
            return etaDataHttpRequest;
        }
        throw new ETAException(ErrorEnum.PARAM_TYPE_ERROR);
    }
}
