package com.qhtx.eta.domain.convert;

import com.alibaba.fastjson.JSON;
import com.qhtx.eta.domain.entity.LinkFieldDTO;
import com.qhtx.eta.domain.entity.LinkInfoDTO;
import com.qhtx.eta.infra.entity.dw.TDampDwLinkInfo;
import org.mapstruct.Mapper;
import org.mapstruct.Mapping;
import org.mapstruct.Named;
import org.mapstruct.factory.Mappers;

import java.util.Collections;
import java.util.List;

@Mapper
public interface TDampDwLinkInfoConverter {
    TDampDwLinkInfoConverter INSTANCE = Mappers.getMapper(TDampDwLinkInfoConverter.class);
    @Mapping(source = "linkFileds", target = "linkFields", qualifiedByName = "strToList")
    LinkInfoDTO convertToDTO(TDampDwLinkInfo tdampDwLinkInfo);

    @Named("strToList")
    default List<LinkFieldDTO> strToList(String fieldsStr) {
        // 验证输入是否为空或仅包含空白字符
        if (fieldsStr == null || fieldsStr.trim().isEmpty()) {
            return Collections.emptyList();
        }
        // 清理字符串，移除可能的前后空格
        String trimmedFieldsStr = fieldsStr.trim();
        // 验证输入字符串是否为有效的JSON数组格式
        try {
            return JSON.parseArray(trimmedFieldsStr, LinkFieldDTO.class);
        } catch (Exception e) {
            // 处理解析错误
            System.err.println("Invalid input: " + trimmedFieldsStr);
            return Collections.emptyList();
        }
    }

}
