package com.qhtx.eta.domain.service.impl;

import com.qhtx.eta.domain.convert.ClassifyMappingDTOConverter;
import com.qhtx.eta.domain.convert.ETAClassifyIndexFrameMappingConverter;
import com.qhtx.eta.domain.entity.ClassifyMappingDTO;
import com.qhtx.eta.domain.entity.LinkDataDTO;
import com.qhtx.eta.domain.service.ETAClassifyService;
import com.qhtx.eta.infra.entity.dw.ETAClassifyIndexFrameMapping;
import com.qhtx.eta.infra.service.EtaApiClassifyService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.List;

@Slf4j
@Service
public class ETAClassifyServiceImpl implements ETAClassifyService {
    @Resource
    private EtaApiClassifyService etaApiClassifyService;

    @Override
    public void syncClassify(List<ClassifyMappingDTO> classifyList) {
        etaApiClassifyService.batchInsertOrUpdate(ETAClassifyIndexFrameMappingConverter.INSTANCE.convertDataToDTOList(classifyList));
    }

    @Override
    public List<ClassifyMappingDTO> getProcessingList() {
        List<ETAClassifyIndexFrameMapping> mappingList = etaApiClassifyService.getProcessingList();
        return ClassifyMappingDTOConverter.INSTANCE.convertEntityToDTOList(mappingList);
    }

    @Override
    public List<ClassifyMappingDTO> getDealedList() {
        return ClassifyMappingDTOConverter.INSTANCE.convertEntityToDTOList(etaApiClassifyService.getDealedList());
    }
}


