package com.qhtx.eta.infra.mapper;

import com.qhtx.eta.infra.entity.dw.TDampDwIndexData;
import org.apache.ibatis.annotations.Param;

import java.util.Date;
import java.util.List;

/**
 * 指标数据表(TDampDwIndexData)表数据库访问层
 *
 * @author makejava
 * @since 2024-09-29 17:37:15
 */
public interface TDampDwIndexDataDao {

    /**
     * 通过ID查询单条数据
     *
     * @return 实例对象
     */
    List<TDampDwIndexData> queryAllByLimit(@Param("indexCode") String indexCode, @Param("offset") int offset, @Param("limit") int limit);

    int countByIndexCode(String indexCode);


    /**
     * 新增数据
     *
     * @param tDampDwIndexData 实例对象
     * @return 影响行数
     */
    int insert(@Param("entity") TDampDwIndexData tDampDwIndexData);

    void insertList(@Param("list") List<TDampDwIndexData> tDampDwIndexDataList);

    List<TDampDwIndexData> queryByDate(@Param("indexCode") String indexCode, @Param("begin") Date beginDate, @Param("offset") int offset, @Param("limit") int limit);

    int countByIndexCodeWithDate(@Param("indexCode") String indexCode, @Param("begin") Date begin);
}

