package com.qhtx.eta.infra.service.impl;

import com.qhtx.eta.common.eunms.DataSourceType;
import com.qhtx.eta.infra.annotation.UseDataSource;
import com.qhtx.eta.infra.entity.dw.ETAClassifyIndexFrameMapping;
import com.qhtx.eta.infra.mapper.ETAClassifyIndexFrameMappingDao;
import com.qhtx.eta.infra.service.EtaApiClassifyService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.util.List;

@UseDataSource(dataSourceType = DataSourceType.DW)
@Service("etaApiClassifyService")
@Slf4j
public class EtaApiClassifyServiceImpl implements EtaApiClassifyService {

    @Resource
    private ETAClassifyIndexFrameMappingDao etaClassifyIndexFrameMappingDao;

    @Override
    public void batchInsertOrUpdate(List<ETAClassifyIndexFrameMapping> etaClassifyIndexFrameMapping) {
        etaClassifyIndexFrameMappingDao.insertOrUpdateBatch(etaClassifyIndexFrameMapping);
    }

    @Override
    public List<ETAClassifyIndexFrameMapping> getProcessingList() {
        return etaClassifyIndexFrameMappingDao.getClassifyMappingList();
    }

    @Override
    public ETAClassifyIndexFrameMapping getByClassifyId(int id) {
        return etaClassifyIndexFrameMappingDao.getByClassifyId(id);
    }

    @Override
    @Transactional
    public void update(ETAClassifyIndexFrameMapping etaClassifyIndexFrameMapping) {
        etaClassifyIndexFrameMappingDao.update(etaClassifyIndexFrameMapping);
    }

    @Override
    public List<ETAClassifyIndexFrameMapping> getDealedList() {
        return etaClassifyIndexFrameMappingDao.getDealedList();
    }
}
