package com.qhtx.eta.config;

import com.google.common.util.concurrent.RateLimiter;
import com.qhtx.eta.common.config.DataSourceProperties;
import com.qhtx.eta.common.eunms.LimiterType;
import com.qhtx.eta.common.limiter.LimiterProvider;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import javax.annotation.Resource;

@Configuration
public class RateLimiterConfig {
    @Resource
    private DataSourceProperties dataSourceProperties;

    @Bean(name = "dataRateLimiter")
    public RateLimiter dataRateLimiter() {
        return (RateLimiter) LimiterProvider.INSTANCE.getLimiter(LimiterType.GUAVA_RATE_LIMITER).offer(dataSourceProperties.getData().getPermitsPerSecond());
    }

    @Bean(name = "quotaRateLimiter")
    public RateLimiter quotaRateLimiter() {
        return (RateLimiter) LimiterProvider.INSTANCE.getLimiter(LimiterType.GUAVA_RATE_LIMITER).offer(dataSourceProperties.getQuota().getPermitsPerSecond());
    }
}
